import jp.jig.jiglet.*;

public class Scheduler extends Jiglet {
	static final int MODE_TOP = 0;
	static final int MODE_INPUT = 1;
	static final int MODE_EDIT = 2;
	static final int MODE_HELP = 3;
	
	int mode;
	int tempMode;
	int[] cursor;
	boolean conciergeFlag = false;
	public void main() {
		readSchedule();
		cursor = new int[4];
		setSoftLabel("VK");
		setMenu(new String[] { "wv" }, new String[] { "wv\܂" });
		mode = MODE_TOP;
		if (getLaunchType() == LAUNCHED_AS_CONCIERGE) {
			conciergeFlag = true;
		}
		clearKey();
		for (;;) {
			repaint();
			sleep(50);
			
			int key = getKey();
			
			if ((key & 0xFF0000) == EVENT_MENU) {
				if ((key & 0xFFFF) == 0) {
					//HELPI
					if (mode != MODE_HELP) {
						tempMode = mode;
						mode = MODE_HELP;
						setSoftLabel("߂");
					}
				}
			}
			
			if (mode == MODE_TOP) {
				if (key == KEY_SOFT) {
					mode = MODE_INPUT;
					cursor[MODE_INPUT] = 2;
					setTime(currentTime());
					inputTime[0] = getTime(CALENDAR_YEAR);
					inputTime[1] = getTime(CALENDAR_MONTH);
					inputTime[2] = getTime(CALENDAR_DATE);
					inputTime[3] = getTime(CALENDAR_HOUR_OF_DAY);
					inputTime[4] = getTime(CALENDAR_MINUTE);
					inputTime[5] = getTime(CALENDAR_DAY_OF_WEEK) - 1;
					inputMemo = null;
					setSoftLabel("߂");
				} else if (key == KEY_SELECT) {
					if (memoCount > 0) {
						mode = MODE_EDIT;
						editTarget = cursor[MODE_TOP];
						cursor[MODE_EDIT] = 2;
						setTime(startTime[editTarget]);
						inputTime[0] = getTime(CALENDAR_YEAR);
						inputTime[1] = getTime(CALENDAR_MONTH);
						inputTime[2] = getTime(CALENDAR_DATE);
						inputTime[3] = getTime(CALENDAR_HOUR_OF_DAY);
						inputTime[4] = getTime(CALENDAR_MINUTE);
						inputTime[5] = getTime(CALENDAR_DAY_OF_WEEK) - 1;
						inputMemo = new String(memo[editTarget]);
					} else {
						mode = MODE_INPUT;
						cursor[MODE_INPUT] = 2;
						setTime(currentTime());
						inputTime[0] = getTime(CALENDAR_YEAR);
						inputTime[1] = getTime(CALENDAR_MONTH);
						inputTime[2] = getTime(CALENDAR_DATE);
						inputTime[3] = getTime(CALENDAR_HOUR_OF_DAY);
						inputTime[4] = getTime(CALENDAR_MINUTE);
						inputTime[5] = getTime(CALENDAR_DAY_OF_WEEK) - 1;
						inputMemo = null;
					}
					setSoftLabel("߂");
				} else if (key == KEY_UP || key == KEY_DOWN) {
					if (memoCount >= (listNum - 1) && (key == KEY_UP && cursor[MODE_TOP] == 0 || key == KEY_DOWN && cursor[MODE_TOP] == memoCount - 1)) {
						if (key == KEY_UP) {
							listTop = memoCount - listNum;
							cursor[MODE_TOP] = memoCount - 1;
						} else {
							listTop = cursor[MODE_TOP] = 0;
						}
					} else if (memoCount > 0) {
						if (key == KEY_UP) {
							if (memoCount < listNum + 1) {
								cursor[MODE_TOP] = (cursor[MODE_TOP] + memoCount - 1) % memoCount;
							} else {
								if (listTop > 0 && cursor[MODE_TOP] == listTop + 1) {
									listTop--;
								}
								cursor[MODE_TOP]--;
							}
						} else {
							if (memoCount < listNum + 1) {
								cursor[MODE_TOP] = (cursor[MODE_TOP] + 1) % memoCount;
							} else {
								if (listTop < memoCount - listNum && cursor[MODE_TOP] == listTop + (listNum - 2)) {
									listTop++;
								}
								cursor[MODE_TOP]++;
							}
						}
					}
				} else if (key == KEY_IAPP) {
					if (conciergeFlag) {
						cursor[MODE_TOP] = 0;
						setState(STATE_JIGLET, JIGLET_DEACTIVE);
						listTop = 0;
						clearKey();
					} else {
						terminate();
					}
				} else if (key == KEY_0) {
					terminate();
				}
			} else if (mode == MODE_INPUT || mode == MODE_EDIT) {
				if (key == KEY_UP) {
					if (editTime == 1) {
						if (cursor[mode] < 5) {
							inputTime[cursor[mode]]++;
							switch (cursor[mode]) {
								case 0: {
									if (inputTime[0] > 2010) {
										inputTime[0] = 2006;
									}
									break;
								}
								case 1: {
									if (inputTime[1] > 11) {
										inputTime[1] = 0;
									}
									if (inputTime[2] > maxDate[inputTime[1]]) {
										inputTime[2] = maxDate[inputTime[1]];
										if (inputTime[1] == 1 && inputTime[0] % 4 == 0) {
											if (inputTime[0] % 100 != 0) {
												inputTime[2] = 29;
											} else if (inputTime[1] % 400 == 0) {
												inputTime[2] = 29;
											}
										}
									}
									break;
								}
								case 2: {
									setTime(CALENDAR_YEAR, inputTime[0]);
									setTime(CALENDAR_MONTH, inputTime[1]);
									setTime(CALENDAR_DATE, inputTime[2]);
									inputTime[2] = getTime(CALENDAR_DATE);
									break;
								}
								case 3: {
									if (inputTime[3] > 23) {
										inputTime[3] = 0;
									}
									break;
								}
								case 4: {
									if (inputTime[4] > 59) {
										inputTime[4] = 0;
									}
									break;
								}
							}
							setTime(CALENDAR_YEAR, inputTime[0]);
							setTime(CALENDAR_MONTH, inputTime[1]);
							setTime(CALENDAR_DATE, inputTime[2]);
							setTime(CALENDAR_HOUR_OF_DAY, inputTime[3]);
							setTime(CALENDAR_MINUTE, inputTime[4]);
							inputTime[5] = getTime(CALENDAR_DAY_OF_WEEK) - 1;
						}
					} else {
						if (cursor[mode] < 5) {
							if (mode == MODE_INPUT) {
								cursor[mode] = 7;
							} else {
								cursor[mode] = 8;
							}
						} else if (cursor[mode] == 5) {
							cursor[mode] = 2;
						} else {
							cursor[mode]--;
						}
					}
				} else if (key == KEY_DOWN) {
					if (editTime == 1) {
						if (cursor[mode] < 5) {
							inputTime[cursor[mode]]--;
							switch (cursor[mode]) {
								case 0: {
									if (inputTime[0] < 2006) {
										inputTime[0] = 2010;
									}
									break;
								}
								case 1: {
									if (inputTime[1] < 0) {
										inputTime[1] = 11;
									}
									break;
								}
								case 2: {
									if (inputTime[2] < 1) {
										inputTime[2] = maxDate[inputTime[1]];
									}
									if (inputTime[2] > maxDate[inputTime[1]]) {
										inputTime[2] = maxDate[inputTime[1]];
										if (inputTime[1] == 1 && inputTime[0] % 4 == 0) {
											if (inputTime[0] % 100 != 0) {
												inputTime[2] = 29;
											} else if (inputTime[1] % 400 == 0) {
												inputTime[2] = 29;
											}
										}
									}
									break;
								}
								case 3: {
									if (inputTime[3] < 0) {
										inputTime[3] = 23;
									}
									break;
								}
								case 4: {
									if (inputTime[4] < 0) {
										inputTime[4] = 59;
									}
									break;
								}
							}
							setTime(CALENDAR_YEAR, inputTime[0]);
							setTime(CALENDAR_MONTH, inputTime[1]);
							setTime(CALENDAR_DATE, inputTime[2]);
							setTime(CALENDAR_HOUR_OF_DAY, inputTime[3]);
							setTime(CALENDAR_MINUTE, inputTime[4]);
							inputTime[5] = getTime(CALENDAR_DAY_OF_WEEK) - 1;
						}
					} else {
						if (cursor[mode] < 5) {
							cursor[mode] = 5;
						} else {
							if (mode == MODE_INPUT) {
								cursor[mode] = (cursor[mode] + 1) % 8;
							} else {
								cursor[mode] = (cursor[mode] + 1) % 9;
							}
						}
					}
				} else if (key == KEY_LEFT) {
					if (editTime == 0) {
						if (cursor[mode] < 5) {
							if (mode == MODE_INPUT) {
								cursor[mode] = 7;
							} else {
								cursor[mode] = 8;
							}
						} else if (cursor[mode] == 5) {
							cursor[mode] = 2;
						} else {
							cursor[mode]--;
						}
					} else {
						cursor[mode] = (cursor[mode] + 5 - 1) % 5;
					}
				} else if (key == KEY_RIGHT) {
					if (editTime == 0) {
						if (cursor[mode] < 5) {
							cursor[mode] = 5;
						} else {
							if (mode == MODE_INPUT) {
								cursor[mode] = (cursor[mode] + 1) % 8;
							} else {
								cursor[mode] = (cursor[mode] + 1) % 9;
							}
						}
					} else {
						cursor[mode] = (cursor[mode] + 1) % 5;
					}
				} else if (key == KEY_SELECT) {
					if (cursor[mode] == 5) { //Memo
						String s = inputText(inputMemo, TEXT_KANA);
						if (s != null) {
							inputMemo = s;
						}
					} else if (cursor[mode] == 6) { //o^
						if (inputMemo != null && inputMemo.length() > 0) {
							setTime(CALENDAR_YEAR, inputTime[0]);
							setTime(CALENDAR_MONTH, inputTime[1]);
							setTime(CALENDAR_DATE, inputTime[2]);
							setTime(CALENDAR_HOUR_OF_DAY, inputTime[3]);
							setTime(CALENDAR_MINUTE, inputTime[4]);
							setTime(CALENDAR_SECOND, 0);
							if (mode == MODE_INPUT) {
								long[] tempTime = new long[memoCount + 1];
								String[] tempMemo = new String[memoCount + 1];
								String[] tempStr = new String[memoCount + 1];
								arraycopy(startTime, 0, tempTime, 1, memoCount);
								arraycopy(memo, 0, tempMemo, 1, memoCount);
								arraycopy(scheduleStr, 0, tempStr, 1, memoCount);
								tempTime[0] = getTime();
								tempMemo[0] = inputMemo;
								tempStr[0] = null;
								startTime = tempTime;
								memo = tempMemo;
								scheduleStr = tempStr;
								memoCount++;
							} else if (mode == MODE_EDIT) {
								startTime[editTarget] = getTime();
								memo[editTarget] = inputMemo;
								scheduleStr[editTarget] = null;
							}
							sortSchedule();
							if (!writeSchedule()) {
								showDialog("eʃI[o[łB\nXPW[폜ĂB", -1);
							}
							mode = MODE_TOP;
							setSoftLabel("VK");
						} else {
							showDialog("͂ĂB", -1);
						}
						
					} else if (cursor[mode] == 7) { //LZ
						mode = MODE_TOP;
						setSoftLabel("VK");
					} else if (cursor[mode] == 8) { //폜
						if (showDialog("폜܂H", 1) == 0) {
							long[] tempTime = new long[memoCount - 1];
							String[] tempMemo = new String[memoCount - 1];
							String[] tempStr = new String[memoCount - 1];
							arraycopy(startTime, 0, tempTime, 0, editTarget);
							arraycopy(startTime, editTarget + 1, tempTime, editTarget, memoCount - editTarget - 1);
							arraycopy(memo, 0, tempMemo, 0, editTarget);
							arraycopy(memo, editTarget + 1, tempMemo, editTarget, memoCount - editTarget - 1);
							arraycopy(scheduleStr, 0, tempStr, 0, editTarget);
							arraycopy(scheduleStr, editTarget + 1, tempStr, editTarget, memoCount - editTarget - 1);
							startTime = tempTime;
							memo = tempMemo;
							scheduleStr = tempStr;
							memoCount--;
							if (cursor[MODE_TOP] >= memoCount) {
								cursor[MODE_TOP] = memoCount - 1;
								if (listTop > 0) {
									listTop--;
								}
							}
							if (!writeSchedule()) {
								showDialog("eʃI[o[łB\nXPW[폜ĂB", -1);
							}
						}
						mode = MODE_TOP;
						setSoftLabel("VK");
					} else {
						editTime = 1 - editTime;
					}
				} else if (key == KEY_IAPP || key == KEY_SOFT) {
					if (editTime == 1) {
						editTime = 0;
					} else {
						mode = MODE_TOP;
						setSoftLabel("VK");
					}
				}
			} else if (mode == MODE_HELP) {
				if (key == KEY_SELECT || key == KEY_IAPP || key == KEY_SOFT) {
					mode = tempMode;
					setSoftLabel("VK");
				}
			}
		}
	}
	
	int fh = 12;
	int[] maxDate = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
	public void paint(boolean allDrawFlag) {
		setFont(0);
		fh = getFontHeight();
		setColor(255, 255, 255);
		fillRect(0, 0, DW, DH);
		
		if (mode == MODE_TOP) {
			if (memoCount == 0 || getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
				if (getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
					setColor(0, 0, 0);
					fillRect(0, 0, DW, DH);
					Image im = getConciergeImage();
					if (im != null) {
						drawImage(im, (DW - im.getWidth()) / 2, (DH - im.getHeight()) / 2);
					}
				}
				setTime(currentTime());
			} else {
				setTime(startTime[cursor[MODE_TOP]]);
			}
			drawCalendar(5, 2, getTime(CALENDAR_YEAR), getTime(CALENDAR_MONTH), getTime(CALENDAR_DATE));
			drawClock(125, 2);
			drawSchedule(5, 100);
		} else if (mode == MODE_INPUT || mode == MODE_EDIT) {
			drawCalendar(5, 2, inputTime[0], inputTime[1], inputTime[2]);
			drawClock(125, 2);
			if (mode == MODE_EDIT) {
				drawSelectSchedule(editTarget, 105, 2 + (fh + 1) * 3, 126);
			}
			drawInputSchedule();
		} else if (mode == MODE_HELP) {
			drawHelp();
		}
	}
	
	void drawClock(int x, int y) {
		setTime(currentTime());
		int year = getTime(CALENDAR_YEAR);
		int month = getTime(CALENDAR_MONTH) + 1;
		int date = getTime(CALENDAR_DATE);
		int hour = getTime(CALENDAR_HOUR_OF_DAY);
		int min = getTime(CALENDAR_MINUTE);
		int sec = getTime(CALENDAR_SECOND);
		int week = getTime(CALENDAR_DAY_OF_WEEK) - 1;
		
		StringBuffer sb = new StringBuffer();
		sb.append(year);
		sb.append('/');
		if (month < 10) {
			sb.append(' ');
		}
		sb.append(month);
		sb.append('/');
		if (date < 10) {
			sb.append(' ');
		}
		sb.append(date);
		sb.append('(');
		sb.append(WEEK.charAt(week));
		sb.append(')');
		if (getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
			drawString(sb.toString(), x, y + fh + 1, getColor(0, 0, 0));
		} else {
			setColor(0, 0, 0);
			drawString(sb.toString(), x, y + fh + 1);
		}
		
		y += fh + 1;
		sb = new StringBuffer();
		if (hour < 10) {
			sb.append(' ');
		}
		sb.append(hour);
		sb.append(':');
		if (min < 10) {
			sb.append('0');
		}
		sb.append(min);
		sb.append(':');
		if (sec < 10) {
			sb.append('0');
		}
		sb.append(sec);
		if (getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
			drawString(sb.toString(), x + 18, y + fh + 1, getColor(0, 0, 0));
		} else {
			drawString(sb.toString(), x + 18, y + fh + 1);
		}
	}
	
	String WEEK = "ΐ؋y";
	void drawCalendar(int x, int y, int year, int month, int date) {
		setTime(CALENDAR_YEAR, year);
		setTime(CALENDAR_MONTH, month);
		setTime(CALENDAR_DATE, 1);
		
		int xmargin = fh + 1;
		int ymargin = fh + 1;
		for (int i = 0; i < 7; i++) {
			if (getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
				if (i == 0) {
					drawString(WEEK.substring(i, i + 1), x + xmargin * i + 1, y + fh + 1, getColor(255, 0, 0));
				} else if (i == 6) {
					drawString(WEEK.substring(i, i + 1), x + xmargin * i + 1, y + fh + 1, getColor(0, 0, 255));
				} else {
					drawString(WEEK.substring(i, i + 1), x + xmargin * i + 1, y + fh + 1, getColor(0, 0, 0));
				}
			} else {
				if (i == 0) {
					setColor(255, 0, 0);
				} else if (i == 6) {
					setColor(0, 0, 255);
				} else {
					setColor(0, 0, 0);
				}
				drawString(WEEK.substring(i, i + 1), x + xmargin * i + 1, y + fh + 1);
			}
		}
		y += ymargin;
		
		int week = getTime(CALENDAR_DAY_OF_WEEK) - 1;
		for (int i = 1; i <= 31; i++) {
			if (getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
				int color;
				if (week == 0) {
					color = getColor(255, 0, 0);
				} else if (week == 6) {
					color = getColor(0, 0, 255);
				} else {
					color = getColor(0, 0, 0);
				}
				if (i < 10) {
					drawString("" + i, x + xmargin * week + 1 + 6, y + fh + 1, color);
				} else {
					drawString("" + i, x + xmargin * week + 1, y + fh + 1, color);
				}
			} else {
				if (week == 0) {
					setColor(255, 0, 0);
				} else if (week == 6) {
					setColor(0, 0, 255);
				} else {
					setColor(0, 0, 0);
				}
				if (i < 10) {
					drawString("" + i, x + xmargin * week + 1 + 6, y + fh + 1);
				} else {
					drawString("" + i, x + xmargin * week + 1, y + fh + 1);
				}
			}
			if (i == date) {
				setColor(0, 255, 0);
				drawLine(x + xmargin * week, y + ymargin, x + xmargin * (week + 1), y + ymargin);
				drawLine(x + xmargin * week, y + ymargin + 1, x + xmargin * (week + 1), y + ymargin + 1);
			}
			if (i >= 28) {
				setTime(CALENDAR_DATE, i + 1);
				if (getTime(CALENDAR_DATE) == 1) {
					break;
				}
			}
			week = (week + 1) % 7;
			if (week == 0) {
				y += ymargin;
			}
		}
	}
	
	int listTop;
	int listNum = 9;
	int memoCount;
	String[] memo;
	long[] startTime;
	String[] scheduleStr;
	void drawSchedule(int sx, int sy) {
		if (memoCount == 0 || startTime == null || memo == null || scheduleStr == null) {
			return;
		}
		long now = currentTime();
		setTime(now);
		setTime(CALENDAR_HOUR_OF_DAY, 0);
		setTime(CALENDAR_MINUTE, 0);
		setTime(CALENDAR_SECOND, 0);
		long today = getTime();
		int w = DW - sx * 2;
		int ch = fh + 3;
		for (int i = 0; i < listNum && listTop + i < memoCount; i++) {
			int x = sx;
			int y = sy + i * ch;
			//I ,  , ܂ 
			if (scheduleStr[listTop + i] == null) {
				scheduleStr[listTop + i] = getTimeString(startTime[listTop + i], 0);
				scheduleStr[listTop + i] += " ";
				if (stringWidth(memo[listTop + i]) > DW - 20 - 40) {
					scheduleStr[listTop + i] += memo[listTop + i].substring(0, getLineBreak(memo[listTop + i], 0, memo[listTop + i].length(), DW - 20 - 40)) + "c";
				} else {
					scheduleStr[listTop + i] += memo[listTop + i];
				}
			}
			if (getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
				if (startTime[listTop + i] < now) {
					drawString(scheduleStr[listTop + i], x + 2, y + fh + 1, getColor(255, 0, 0));
				} else if (startTime[listTop + i] >= today && startTime[listTop + i] < today + 86400000) {
					drawString(scheduleStr[listTop + i], x + 2, y + fh + 1, getColor(0, 0, 255));
				} else {
					drawString(scheduleStr[listTop + i], x + 2, y + fh + 1, getColor(0, 0, 0));
				}
			} else {
				if (startTime[listTop + i] < now) {
					setColor(255, 0, 0);
				} else if (startTime[listTop + i] >= today && startTime[listTop + i] < today + 86400000) {
					setColor(0, 0, 255);
				} else {
					setColor(0, 0, 0);
				}
				drawString(scheduleStr[listTop + i], x + 2, y + fh + 1);
			}
			if (listTop + i == cursor[MODE_TOP] && getState(STATE_JIGLET) < JIGLET_DEACTIVE) {
				drawSelectSchedule(listTop + i, 105, 2 + (fh + 1) * 3, 126);
				drawRect(x, y, w, ch);
			}
		}
		if (getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
			for (int i = 0; i < memoCount; i++) {
				if (startTime[i] > now) {
					drawSelectSchedule(i, 105, 2 + (fh + 1) * 3, 126);
					drawRect(sx, sy + i * ch, w, ch, getColor(0, 0, 0));
					break;
				}
			}
		}
		if (memoCount > listNum && getState(STATE_JIGLET) < JIGLET_DEACTIVE) {
			int x = sx + 4;
			int h = ch * listNum;
			setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BG));
			fillRect(x + w - 3, sy + 1, 3, h);
			setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BAR));
			int sch = h * listNum / memoCount;
			int scy;
			if (listTop + listNum == memoCount) {
				scy = sy + h - sch;
			} else {
				scy = sy + h * listTop / memoCount;
			}
			fillRect(x + w - 3, scy, 3, sch + 1);
		}
	}
	
	void drawSelectSchedule(int n, int x, int y, int w) {
		if (getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
			drawString(getTimeString(startTime[n], 1), x, y + fh + 1, getColor(0, 0, 0));
			drawString(memo[n], x + 5, y + fh + 1 + 2, w, 2, getColor(0, 0, 0));
		} else {
			setColor(0, 0, 0);
			drawString(getTimeString(startTime[n], 1), x, y + fh + 1);
			drawString(memo[n], x + 5, y + fh + 1 + 2, w, 2);
		}
	}
	
	String getTimeString(long time, int type) {
		setTime(time);
		int year = getTime(CALENDAR_YEAR);
		int month = getTime(CALENDAR_MONTH) + 1;
		int date = getTime(CALENDAR_DATE);
		int hour = getTime(CALENDAR_HOUR_OF_DAY);
		int min = getTime(CALENDAR_MINUTE);
		
		StringBuffer sb = new StringBuffer();
		setTime(currentTime());
		if (type == 0) {
			if (year == getTime(CALENDAR_YEAR) && month == (getTime(CALENDAR_MONTH) + 1) && date == getTime(CALENDAR_DATE)) {
				if (hour < 10) {
					sb.append(' ');
				}
				sb.append(hour);
				sb.append(':');
				if (min < 10) {
					sb.append('0');
				}
				sb.append(min);
			} else {
				if (month < 10) {
					sb.append(' ');
				}
				sb.append(month);
				sb.append('/');
				if (date < 10) {
					sb.append(' ');
				}
				sb.append(date);
			}
		} else {
			if (month < 10) {
				sb.append(' ');
			}
			sb.append(month);
			sb.append('/');
			if (date < 10) {
				sb.append(' ');
			}
			sb.append(date);
			sb.append('(');
			sb.append(WEEK.charAt(getTime(CALENDAR_DAY_OF_WEEK) - 1));
			sb.append(") ");
			if (hour < 10) {
				sb.append(' ');
			}
			sb.append(hour);
			sb.append(':');
			if (min < 10) {
				sb.append('0');
			}
			sb.append(min);
		}
		return sb.toString();
	}
	
	int[] inputTime = new int[6];
	int editTime;
	String inputMemo;
	int editTarget;
	void drawInputSchedule() {
		int ch = fh + 5;
		int margin = 5;
		int w = DW;
		int h = ch * 7 + margin * 4;
		int x = (DW - w) / 2;
		int y = DH - h;
		draw3DButton(x, y, w, h);
		x += margin;
		y += margin;
		StringBuffer sb = new StringBuffer();
		sb.append(inputTime[0]);
		sb.append('/');
		if (inputTime[1] < 9) {
			sb.append(' ');
		}
		sb.append(inputTime[1] + 1);
		sb.append('/');
		if (inputTime[2] < 10) {
			sb.append(' ');
		}
		sb.append(inputTime[2]);
		sb.append('(');
		sb.append(WEEK.charAt(inputTime[5]));
		sb.append(") ");
		if (inputTime[3] < 10) {
			sb.append(' ');
		}
		sb.append(inputTime[3]);
		sb.append(':');
		if (inputTime[4] < 10) {
			sb.append('0');
		}
		sb.append(inputTime[4]);
		setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
		drawString(sb.toString(), x, y + fh + 1);
		setColor(getSystemColor(SYSTEM_COLOR_BUTTON_CURSOR));
		if (editTime == 1) {
			switch (cursor[mode]) {
				case 0:
					drawRect(x, y, 6 * 4, fh + 1);
					break;
				case 1:
					drawRect(x + 6 * 5, y, 6 * 2, fh + 1);
					break;
				case 2:
					drawRect(x + 6 * 8, y, 6 * 2, fh + 1);
					break;
				case 3:
					drawRect(x + 6 * 15, y, 6 * 2, fh + 1);
					break;
				case 4:
					drawRect(x + 6 * 18, y, 6 * 2, fh + 1);
			}
		} else {
			if (cursor[mode] < 5) {
				drawLine(x, y + fh + 1, x + 6 * 20, y + fh + 1);
				drawLine(x, y + fh + 2, x + 6 * 20, y + fh + 2);
			}
		}
		y += ch + margin;
		draw3DRect(x, y, w - margin * 2, ch * 5);
		if (cursor[mode] == 5) {
			setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
			fillRect(x + 1, y + 1, w - margin * 2 - 1, ch * 5 - 1);
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
		} else {
			setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
		}
		if (inputMemo != null) {
			drawString(inputMemo, x + 2, y + 2, w - margin * 2 - 4, 5);
		}
		y += ch * 5 + margin;
		//o^
		draw3DButton(x, y, 30, ch);
		if (cursor[mode] == 6) {
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_CURSOR));
			fillRect(x + 1, y + 1, 30 - 1, ch - 1);
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT2));
		} else {
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
		}
		drawString("o^", x + 2, y + fh + 1);
		
		//LZ
		x += 30 + margin;
		draw3DButton(x, y, 40, ch);
		if (cursor[mode] == 7) {
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_CURSOR));
			fillRect(x + 1, y + 1, 40 - 1, ch - 1);
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT2));
		} else {
			setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
		}
		drawString("ݾ", x + 2, y + fh + 1);
		
		if (mode == MODE_EDIT) {
			//폜
			x += 40 + margin;
			draw3DButton(x, y, 30, ch);
			if (cursor[mode] == 8) {
				setColor(getSystemColor(SYSTEM_COLOR_BUTTON_CURSOR));
				fillRect(x + 1, y + 1, 30 - 1, ch - 1);
				setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT2));
			} else {
				setColor(getSystemColor(SYSTEM_COLOR_BUTTON_FONT1));
			}
			drawString("폜", x + 2, y + fh + 1);
		}
	}
	
	void drawHelp() {
		setColor(0, 0, 0);
		int x = 2;
		int y = 2;
		drawString("J_[", x, y + fh + 1);
		y += fh + 1;
		drawString("@I𒆂̃XPW[̌\", x, y + fh + 1);
		y += fh + 1;
		drawString("@XPW[Ȃ͍\", x, y + fh + 1);
		y += fh + 1;
		drawString("@XPW[͓͒͂\", x, y + fh + 1);
		y += fh + 1;
		y += fh + 1;
		drawString("XPW[̐F", x, y + fh + 1);
		y += fh + 1;
		drawString("@ԁFt߂", x, y + fh + 1);
		setColor(255, 0, 0);
		drawString("@", x, y + fh + 1);
		setColor(0, 0, 0);
		y += fh + 1;
		drawString("@F̂", x, y + fh + 1);
		setColor(0, 0, 255);
		drawString("@", x, y + fh + 1);
		setColor(0, 0, 0);
		y += fh + 1;
		drawString("@Fȍ~̂", x, y + fh + 1);
		y += fh + 1;
		y += fh + 1;
		drawString("Ҏ", x, y + fh + 1);
		y += fh + 1;
		drawString("@̃XPW[\", x, y + fh + 1);
	}
	
	void drawString(String str, int x, int y, int w, int rows) {
		if (str == null || str.length() == 0) {
			return;
		}
		int skiph = 1;
		int len = str.length();
		int startIdx = 0;
		int endIdx = 0;
		int nlIdx = 0;
		for (int i = 0; startIdx < len && i < rows; i++) {
			endIdx = getLineBreak(str, startIdx, len - startIdx, w);
			nlIdx = str.indexOf("\n", startIdx);
			if (nlIdx == -1 || nlIdx > endIdx) {
				drawString(str.substring(startIdx, endIdx), x, y + fh + 1);
				startIdx = endIdx;
			} else {
				nlIdx++;
				drawString(str.substring(startIdx, nlIdx), x, y + fh + 1);
				startIdx = nlIdx;
			}
			y += fh + skiph;
		}
	}
	
	void drawString(String str, int x, int y, int w, int rows, int color) {
		if (str == null || str.length() == 0) {
			return;
		}
		int skiph = 1;
		int len = str.length();
		int startIdx = 0;
		int endIdx = 0;
		int nlIdx = 0;
		for (int i = 0; startIdx < len && i < rows; i++) {
			endIdx = getLineBreak(str, startIdx, len - startIdx, w);
			nlIdx = str.indexOf("\n", startIdx);
			if (nlIdx == -1 || nlIdx > endIdx) {
				drawString(str.substring(startIdx, endIdx), x, y + fh + 1, color);
				startIdx = endIdx;
			} else {
				nlIdx++;
				drawString(str.substring(startIdx, nlIdx), x, y + fh + 1, color);
				startIdx = nlIdx;
			}
			y += fh + skiph;
		}
	}
	
	void drawString(String str, int x, int y, int color) {
		setColor(255, 255, 255);
		drawString(str, x - 1, y);
		drawString(str, x + 1, y);
		drawString(str, x, y + 1);
		drawString(str, x, y - 1);
		setColor(color);
		drawString(str, x, y);
	}
	
	void drawRect(int x, int y, int w, int h, int color) {
		setColor(255, 255, 255);
		drawRect(x - 1, y - 1, w + 2, h + 2);
		drawRect(x + 1, y + 1, w - 2, h - 2);
		setColor(color);
		drawRect(x, y, w, h);
	}
	
	void sortSchedule() {
		if (memoCount < 2) {
			return;
		}
		for (int i = 0; i < memoCount - 1; i++) {
			for (int j = i + 1; j < memoCount; j++) {
				if (startTime[i] > startTime[j]) {
					long l = startTime[i];
					startTime[i] = startTime[j];
					startTime[j] = l;
					String s = memo[i];
					memo[i] = memo[j];
					memo[j] = s;
					String s2 = scheduleStr[i];
					scheduleStr[i] = scheduleStr[j];
					scheduleStr[j] = s2;
				}
			}
		}
	}
	
	static final int SP_SIZE = 1024;
	boolean writeSchedule() {
		int size = 1;
		for (int i = 0; i < memoCount; i++) {
			size += 10;
			size += memo[i].getBytes().length;
		}
		if (size > SP_SIZE) {
			return false;
		}
		byte[] b = new byte[size];
		int idx = 0;
		b[idx++] = (byte)(0xFF & memoCount);
		for (int i = 0; i < memoCount; i++) {
			for (int j = 0; j < 8; j++) {
				b[idx++] = (byte)(startTime[i] >> (8 * (7 - j)));
			}
		}
		for (int i = 0; i < memoCount; i++) {
			byte[] b2 = memo[i].getBytes();
			b[idx++] = (byte)(b2.length >> 8);
			b[idx++] = (byte)(b2.length);
			arraycopy(b2, 0, b, idx, b2.length);
			idx += b2.length;
		}
		writeSP(0, b);
		return true;
	}
	
	boolean readSchedule() {
		byte[] b = readSP(0, SP_SIZE);
		int idx = 0;
		memoCount = 0xFF & b[idx++];
		startTime = new long[memoCount];
		memo = new String[memoCount];
		scheduleStr = new String[memoCount];
		if (memoCount == 0) {
			return false;
		}
		for (int i = 0; i < memoCount; i++) {
			startTime[i] = ((long)(b[idx++] & 0xffL)) << 56 | ((long)(b[idx++] & 0xffL)) << 48 | ((long)(b[idx++] & 0xffL)) << 40 | ((long)(b[idx++] & 0xffL)) << 32 | ((long)(b[idx++] & 0xffL)) << 24 | ((long)(b[idx++] & 0xffL)) << 16 | ((long)(b[idx++] & 0xffL)) << 8 | ((long)(b[idx++] & 0xffL));
		}
		for (int i = 0; i < memoCount; i++) {
			int size = ((0xFF & b[idx++]) << 8) | (0xFF & b[idx++]);
			memo[i] = new String(b, idx, size);
			idx += size;
		}
		return true;
	}
}
